#include "stdlib.h"
#include "string.h"
#include "stdio.h"
#include "tchar.h"

#define AYREG_MAX 16 // for standard AY\YM

typedef struct {
	int data, dirty;
} ayreg;

ayreg ayregs[256] = {0};

unsigned int count = 0;

void print_ayregs(ayreg in[]) {
	printf("%08d: ", count);
	for (int i = 0; i < AYREG_MAX; i++) {
		printf("%02X%c ", in[i].data, in[i].dirty ? '*' : ' ');
		in[i].dirty = 0;
	}
	wprintf(L"\n"); count++;
}

int _tmain(int argc, _TCHAR* argv[]) {
	_TCHAR psgname[256];
	FILE *psg;

    if (argc < 2) {
		fwprintf(stderr, L"usage: psgtxt <filename.psg>\n");
		return 1;
	}

	wcscpy_s(psgname, sizeof(_TCHAR)*256, argv[1]);

	_wfopen_s(&psg, psgname, L"rb");
	if (!psg) {
		fwprintf(stderr, L"error opening file %ls:\n", psgname); perror(0);
		return 1;
	}

	// check for signature
	char sign[4];
	fread_s(&sign, sizeof(char) * 4, sizeof(char), 4, psg);
	if (strncmp(sign, "PSG\x1A", 4)) {
		fwprintf(stderr, L"error: invalid file format");
		return 1;
	}

	unsigned char ch;
	// process loop
	while (!feof(psg)) {
		fread_s(&ch, sizeof(unsigned char), sizeof(unsigned char), 1, psg);
		switch(ch) {
		case 0xFF :
			// end of frame
			print_ayregs(ayregs);
			break;
		case 0xFE:
			// end of n*4 frames
			fread_s(&ch, sizeof(unsigned char), sizeof(unsigned char), 1, psg);
			for (int i = 0; i < ch*4; i++) print_ayregs(ayregs);
			break;
		case 0xFD:
			// end of track
			goto eot; // :(
			break;
		default:
			// write to register ch
			fread_s(&ayregs[ch].data, sizeof(unsigned int), sizeof(unsigned char), 1, psg);
			ayregs[ch].dirty = 1;
			break;
		}
	}
	eot:

	fclose(psg);
	return 0;
}